# Institution MS - ID Care - Backend #

Este é o microserviço de instituições do projeto id-care.

Desenvolvido em GoLang e voltado para uma arquitetura de microserviços.

Para realizar testes localmente, é recomendado que se utilize o Docker para "hospedar" o MongoDB.

![image](https://drive.google.com/uc?export=view&id=1ZLharI_D8wSTfOY2fGUGU45ZNtBu7MGX)

### Dependências ###

| App | Motivo | Versão |
| --- | --- | --- |
| GoLang | Codificação | 1.16.2 |
| Docker | Testes locais | 20.10.5 |

### Aplicações utilizadas ###
| App | Utilização | Motivo | Versão |
| --- | --- | --- | --- |
| Gin-Gonic | Código | Construção API RESTful | 1.6.3 |
| Mongo GO Driver | Código | Comunicação com MongoDB | 1.5.0 |
| Go Dot Env | Código | Carregamento de variáveis de ambiente | 1.3.0 |
| Testify | Código | Realização de testes | 1.7.0 |
| Mongo | Docker | Persistência de dados | 4.4.4
| Mongo-Express | Docker | Visualização WEB para o Mongo | 0.54.0 |

### Documentações ###
- [Gin Gonic](https://github.com/gin-gonic/gin/blob/master/README.md)
- [Mongo GO Driver](https://pkg.go.dev/go.mongodb.org/mongo-driver/mongo@v1.5.0)
- [GoDotEnv](https://github.com/joho/godotenv)
- [Testify](https://github.com/stretchr/testify)

### Como rodar o projeto? ###

Para iniciar o banco de dados Mongo, executar na raíz do projeto (`/boilerplate`):

```shell
$ docker-compose up -d
```

Para iniciar o servidor HTTP, executar na raíz do projeto (`/boilerplate`):

```shell
$ GOOS=<sistema-operacional> go build -o build/

$ GIN_MODE=release ./build/boilerplate
```

### Como testar? ###

Para testar a rota POST /user, utilize o comando:
```shell
$ curl -X POST http://localhost:8080/user -d '{"name": "bla", "email": "bla@email.com"}' -H "Content-Type:application/json"
```

Para testar a rota GET /user, utilize o comando:
```shell
$ curl -X GET http://localhost:8080/user/bla@email.com 
```

Ou pode-se utilizar os testes criados da seguinte forma:
```shell
$ GIN_MODE=release go test ./test
```