/*
	-> Este é um arquivo base para desenvolvimento na camada de Repositório;
	-> Codifique em inglês utilizando os termos definidos no glossário;
	-> Qualquer dúvida contate um AGES 3.
*/
package repository

import (
	"institutionMS/layers/entity"
	"institutionMS/layers/infrastructure"
)

// InstitutionRepository is a struct that defines a institution Repository behaviour at repository layer
type InstitutionRepository struct {
	Database                 infrastructure.DocumentDatabase
	TargetDocumentDatabase   string
	TargetDocumentCollection string
}

// Load searches for a Institution in a TargetDocumentDatabase based on id
func (repository InstitutionRepository) Load(id string) (institution *entity.Institution) {
	repository.Database.Connect()
	defer repository.Database.Disconnect()
	repository.Database.Collection(repository.TargetDocumentDatabase, repository.TargetDocumentCollection)
	institution = repository.Database.Load(id)
	return
}

// Save inserts a Institution in TargetDocumentDatabase and returns its given id
func (repository InstitutionRepository) Save(institution entity.Institution) (id string) {
	repository.Database.Connect()
	defer repository.Database.Disconnect()
	repository.Database.Collection(repository.TargetDocumentDatabase, repository.TargetDocumentCollection)
	id = repository.Database.Save(institution)
	return
}

// Update a Institution in a TargetDocumentDatabase based on id
func (repository InstitutionRepository) Update(id string, institution *entity.Institution) (updated *entity.Institution, err error) {
	repository.Database.Connect()
	defer repository.Database.Disconnect()
	repository.Database.Collection(repository.TargetDocumentDatabase, repository.TargetDocumentCollection)
	return repository.Database.Update(id, institution)
}
