/*
	-> Este é um arquivo base para desenvolvimento para a entrada da aplicação;
	-> Codifique em inglês utilizando os termos definidos no glossário;
	-> Qualquer dúvida contate um AGES 3.
*/
package main

import (
	"institutionMS/factory"
	"log"
	"github.com/gin-gonic/gin"
	"github.com/joho/godotenv"
)

const env = ".env"

func main() {
	err := godotenv.Load(env)

	if err != nil {
		log.Fatal("Error loading .env file")
	}

	ginRouter := gin.Default()
	appRouter := factory.CreateInstitutionApp()
	appRouter.Create(ginRouter)
	err = ginRouter.Run("0.0.0.0:8080")

	if err != nil {
		log.Fatal(error.Error(err))
	}
}
